Import Submission
Import a submission into your Vault.
Before submitting this request:
- You must be assigned permissions to use the API and have permissions to view and edit the specified
submission__vobject record. - You must create the corresponding object records for the Submission and Application objects in your Vault.
- You must create and upload a valid submission import file or folder to file staging. The submission to import must be in a specific location and format.
Submission Import File Location & Structure
Section link for Submission Import File Location & StructureThe submission import file must be located in one of the following places, and must be in a specific folder structure.
At the Root
Section link for At the RootIf your submission import is located at the file staging root, it must follow the following structure:
/SubmissionsArchive/{application_folder}/{submission_file_or_folder}: This required folder can have any name you wish.{application_folder}: If this is a file containing your submission, it must be a{submission_file_or_folder}.zipor.tar.gz. If this is a folder, it must contain your submission to import. This required folder can have any name you wish.
For example, /SubmissionsArchive/.nda654321/0001.zip
Within a User Folder
Section link for Within a User FolderIn some cases, your Vault user permissions may prevent you from uploading directly to the file staging root. In these cases, you must upload to your user folder using the following structure:
/u[ID]/Submissions Archive Import/{application_folder}/{submission_folder}: This required folder can have any name you wish.{application_folder}: The folder containing your submission to import. This required folder can have any name you wish. Vault does not support importing{submission_folder}.zipor.tar.gzfiles from user folders.
For example, /u5678/Submissions Archive Import/.nda123456/0013
Endpoint
Section link for Endpoint/api/{version}/vobjects/submission__v/{submission_id}/actions/importHeaders
Section link for Headers| Name | Description |
|---|---|
Content-Type | application/x-www-form-urlencoded |
Accept | application/json (default) or application/xml |
URI Path Parameters
Section link for URI Path Parameters| Name | Description |
|---|---|
{submission_id} | The id field value of the submission__v object record. To get this value, use VQL to retrieve all records on the submission__v object. |
Body Parameters
Section link for Body Parameters| Name | Description |
|---|---|
file | Use the file parameter to specify the location of the submission folder or ZIP file previously uploaded to file staging. In the request, add the file parameter to your input and enter the path to the submission folder relative to the file staging root, for example, /SubmissionsArchive/nda123456/0000, or to the path to your user file staging folder, for example, /u5678/Submissions Archive Import/nda123456/0000. Vault does not support importing .zip or .tar.gz files from user folders. |
Request
Section link for Requestcurl -X POST -H "Authorization: {SESSION_ID}" \
-H "Content-Type: application/x-www-form-urlencoded" \
-d "file=/nda123456/0000" \
https://myvault.veevavault.com/api/v26.1/vobjects/submission__v/00S000000000101/actions/importResponse
Section link for Response{
"responseStatus": "SUCCESS",
"warnings": [
{
"type": "APPLICATION_MISMATCH",
"message": "Application folder name does not match the Application record name."
},
{
"type": "SUBMISSION_MISMATCH",
"message": "Submission folder name does not match the Submission record name."
}
],
"job_id": 1301,
"url": "/api/v26.1/services/jobs/1301"
}Response Details
Section link for Response DetailsOn SUCCESS, the response includes the following information:
job_id- The Job ID value is used to retrieve the status and results of the binder export request.url- The URL to retrieve the current status of the import request.
You may also receive one or more warnings. The warnings shown above indicate that the folders being imported do not match the object records in our Vault. To fix this warning, we can change the folder name or object record name. However, warnings are not fatal and you may choose to take no action.
Before submitting this request, we created a submission__v object record and application__v object record in our Vault. We also created submissions ZIP file containing a "Submission" folder and "Application" folder. This was loaded to file staging awaiting import. Ideally, we would have named and structured the folders to match that of the submission that was sent to the health authority and which we are now archiving. However, this is not critical to the import process.